diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets.c freeciv-patched/common/packets.c
--- freeciv-cvs/common/packets.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/packets.c	2003-07-07 18:21:49.000000000 +0100
@@ -38,6 +38,7 @@
 #include "dataio.h"
 #include "events.h"
 #include "fcintl.h"
+#include "government.h"
 #include "log.h"
 #include "mem.h"
 #include "support.h"
@@ -425,6 +426,12 @@
     return receive_packet_ruleset_government_ruler_title(pc);
   case PACKET_RULESET_NATION:
     return receive_packet_ruleset_nation(pc);
+  case PACKET_RULESET_MODIFIER_TYPE:
+    return receive_packet_ruleset_modifier_type(pc);
+  case PACKET_RULESET_MODIFIER:
+    return receive_packet_ruleset_modifier(pc);
+  case PACKET_REQUEST_COMPOUND:
+    return receive_packet_request_compound(pc);
   case PACKET_RULESET_CITY:
     return receive_packet_ruleset_city(pc);
   case PACKET_RULESET_GAME:
@@ -1890,6 +1897,12 @@
   if (has_capability("impr_gen", pc->capability)) {
     dio_put_uint8(&dout, packet->num_unit_flags);
   }
+  if (has_capability("compounds", pc->capability)) {
+    dio_put_uint8(&dout, packet->num_unit_modifier_types);
+    dio_put_uint8(&dout, packet->num_unit_modifiers);
+    dio_put_uint8(&dout, packet->num_gov_modifier_types);
+    dio_put_uint8(&dout, packet->num_gov_modifiers);
+  }
   dio_put_uint8(&dout, packet->num_unit_types);
   dio_put_uint8(&dout, packet->num_impr_types);
   dio_put_uint8(&dout, packet->num_tech_types);
@@ -1941,6 +1954,15 @@
   } else {
     packet->num_unit_flags = F_LAST;
   }
+  if (has_capability("compounds", pc->capability)) {
+    dio_get_uint8(&din, &packet->num_unit_modifier_types);
+    dio_get_uint8(&din, &packet->num_unit_modifiers);
+    dio_get_uint8(&din, &packet->num_gov_modifier_types);
+    dio_get_uint8(&din, &packet->num_gov_modifiers);
+  } else {
+    packet->num_unit_modifier_types = packet->num_unit_modifiers = 0;
+    packet->num_gov_modifier_types  = packet->num_gov_modifiers = 0;
+  }
   dio_get_uint8(&din, &packet->num_unit_types);
   dio_get_uint8(&din, &packet->num_impr_types);
   dio_get_uint8(&din, &packet->num_tech_types);
@@ -2009,6 +2031,13 @@
   if (has_capability("impr_gen", pc->capability)) {
     dio_put_effects(&dout, pc, packet->effect);
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_put_uint16(&dout, packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_put_uint16(&dout, packet->modifiers[i]);
+    }
+  }
 
   /* This must be last, so client can determine length: */
   if(packet->helptext) {
@@ -2076,6 +2105,15 @@
     packet->effect = fc_malloc(sizeof(struct impr_effect));
     packet->effect[0].type = EFT_LAST;
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_get_uint16(&din, &packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_get_uint16(&din, &packet->modifiers[i]);
+    }
+  } else {
+    packet->basetype = U_LAST;
+  }
 
   len = dio_input_remaining(&din);
   if (len > 0) {
@@ -2162,6 +2200,123 @@
 /**************************************************************************
 ...
 **************************************************************************/
+int send_packet_ruleset_modifier_type(struct connection *pc,
+                const struct packet_ruleset_modifier_type *packet)
+{
+  SEND_PACKET_START(PACKET_RULESET_MODIFIER_TYPE);
+
+  dio_put_uint8(&dout, packet->id);
+  dio_put_bool8(&dout, packet->is_gov);
+  dio_put_uint8(&dout, packet->basetype);
+  dio_put_string(&dout, packet->name);
+  dio_put_uint8(&dout, packet->tech_requirement);
+  dio_put_bool8(&dout, packet->must_use);
+
+  SEND_PACKET_END;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct packet_ruleset_modifier_type *
+receive_packet_ruleset_modifier_type(struct connection *pc)
+{
+  RECEIVE_PACKET_START(packet_ruleset_modifier_type, packet);
+
+  dio_get_uint8(&din, &packet->id);
+  dio_get_bool8(&din, &packet->is_gov);
+  dio_get_uint8(&din, &packet->basetype);
+  dio_get_string(&din, packet->name, sizeof(packet->name));
+  dio_get_uint8(&din, &packet->tech_requirement);
+  dio_get_bool8(&din, &packet->must_use);
+
+  RECEIVE_PACKET_END(packet);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+int send_packet_ruleset_modifier(struct connection *pc,
+                const struct packet_ruleset_modifier *packet)
+{
+  SEND_PACKET_START(PACKET_RULESET_MODIFIER);
+
+  dio_put_uint8(&dout, packet->id);
+  dio_put_bool8(&dout, packet->is_gov);
+  dio_put_string(&dout, packet->name);
+  dio_put_uint8(&dout, packet->type);
+  dio_put_uint8(&dout, packet->tech_requirement);
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_effects(&dout, pc, packet->effect);
+  }
+
+  SEND_PACKET_END;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct packet_ruleset_modifier *
+receive_packet_ruleset_modifier(struct connection *pc)
+{
+  RECEIVE_PACKET_START(packet_ruleset_modifier, packet);
+
+  dio_get_uint8(&din, &packet->id);
+  dio_get_bool8(&din, &packet->is_gov);
+  dio_get_string(&din, packet->name, sizeof(packet->name));
+  dio_get_uint8(&din, &packet->type);
+  dio_get_uint8(&din, &packet->tech_requirement);
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_effects(&din, pc, &packet->effect);
+  } else {
+    packet->effect = fc_malloc(sizeof(struct impr_effect));
+    packet->effect[0].type = EFT_LAST;
+  }
+
+  RECEIVE_PACKET_END(packet);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+int send_packet_request_compound(struct connection *pc,
+				 struct packet_request_compound *req)
+{
+  int i;
+  SEND_PACKET_START(PACKET_REQUEST_COMPOUND);
+
+  dio_put_bool8(&dout, req->is_gov);
+  dio_put_string(&dout, req->name);
+  dio_put_uint16(&dout, req->basetype);
+  for (i = 0; i < MAX_MODS; ++i) {
+    dio_put_uint16(&dout, req->modifiers[i]);
+  }
+
+  SEND_PACKET_END;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct packet_request_compound *
+receive_packet_request_compound(struct connection *pc)
+{
+  int i;
+  RECEIVE_PACKET_START(packet_request_compound, packet);
+
+  dio_get_bool8(&din, &packet->is_gov);
+  dio_get_string(&din, packet->name, sizeof(packet->name));
+  dio_get_uint16(&din, &packet->basetype);
+  for (i = 0; i < MAX_MODS; ++i) {
+    dio_get_uint16(&din, &packet->modifiers[i]);
+  }
+
+  RECEIVE_PACKET_END(packet);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 static void dio_put_effects(struct data_out *dout,
                             struct connection *pc,
                             const struct impr_effect *effect)
@@ -2186,6 +2341,9 @@
     }
     dio_put_uint8(dout, eff->cond_bldg);
     dio_put_uint8(dout, eff->cond_gov);
+    if (has_capability("compounds", pc->capability)) {
+      dio_put_uint8(dout, eff->cond_govmod);
+    }
     dio_put_uint8(dout, eff->cond_adv);
     dio_put_uint8(dout, eff->cond_eff);
     dio_put_uint8(dout, eff->aff_unit);
@@ -2266,6 +2424,9 @@
     }
     dio_get_uint8(din, &(effect[inx].cond_bldg));
     dio_get_uint8(din, &(effect[inx].cond_gov));
+    if (has_capability("compounds", pc->capability)) {
+      dio_get_uint8(din, &(effect[inx].cond_govmod));
+    }
     dio_get_uint8(din, &(effect[inx].cond_adv));
     dio_get_uint8(din, (int *)&(effect[inx].cond_eff));
     dio_get_uint8(din, (int *)&(effect[inx].aff_unit));
@@ -2588,6 +2749,13 @@
   if (has_capability("impr_gen", pc->capability)) {
     dio_put_effects(&dout, pc, packet->effect);
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_put_uint16(&dout, packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_put_uint16(&dout, packet->modifiers[i]);
+    }
+  }
 
   /* This must be last, so client can determine length: */
   if(packet->helptext) {
@@ -2688,6 +2856,15 @@
     packet->effect = fc_malloc(sizeof(struct impr_effect));
     packet->effect[0].type = EFT_LAST;
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_get_uint16(&din, &packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_get_uint16(&din, &packet->modifiers[i]);
+    }
+  } else {
+    packet->basetype = G_MAGIC;
+  }
 
   len = dio_input_remaining(&din);
   if (len > 0) {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets.h freeciv-patched/common/packets.h
--- freeciv-cvs/common/packets.h	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/packets.h	2003-07-07 18:21:49.000000000 +0100
@@ -128,6 +128,9 @@
   PACKET_FREEZE_HINT,
   PACKET_THAW_HINT,
   PACKET_PING_INFO,
+  PACKET_RULESET_MODIFIER_TYPE,
+  PACKET_RULESET_MODIFIER,
+  PACKET_REQUEST_COMPOUND,
   PACKET_LAST  /* leave this last */
 };
 
@@ -572,6 +575,10 @@
   int num_unit_types;
   int num_impr_types;
   int num_tech_types;
+  int num_unit_modifier_types;
+  int num_unit_modifiers;
+  int num_gov_modifier_types;
+  int num_gov_modifiers;
   struct {
     int cathedral_plus;
     int cathedral_minus;
@@ -628,6 +635,9 @@
   int paratroopers_mr_sub;
   struct impr_effect *effect;
 
+  int basetype;
+  int modifiers[MAX_MODS];
+
   /* Following is a pointer to malloced memory; on the server, it
      points to putype->helptext, malloced earlier; on the client,
      it is malloced when packet received, and then putype->helptext
@@ -636,6 +646,33 @@
   char *helptext;
 };
 
+struct packet_ruleset_modifier_type {
+  bool is_gov;
+  int id;
+  char name[MAX_LEN_NAME];
+  int basetype;
+  int tech_requirement;
+  bool must_use;
+};
+
+struct packet_ruleset_modifier {
+  bool is_gov;
+  int id;
+  char name[MAX_LEN_NAME];
+  int type;
+  int tech_requirement;
+  char *action;
+  char *final_action;
+  struct impr_effect *effect;
+};
+
+struct packet_request_compound {
+  bool is_gov;
+  int basetype;
+  char name[MAX_LEN_NAME];
+  int modifiers[MAX_MODS];
+};
+
 struct packet_ruleset_tech {
   int id, req[2], root_req;	/* indices for advances[] */
   int flags;
@@ -729,6 +766,9 @@
   int empire_size_mod;
   int empire_size_inc;
   int rapture_size;
+
+  int basetype;
+  int modifiers[MAX_MODS];
       
   int unit_happy_cost_factor;
   int unit_shield_cost_factor;
@@ -1061,6 +1101,19 @@
 struct packet_ruleset_unit *
 receive_packet_ruleset_unit(struct connection *pc);
 
+int send_packet_ruleset_modifier_type(struct connection *pc,
+                const struct packet_ruleset_modifier_type *packet);
+struct packet_ruleset_modifier_type *
+receive_packet_ruleset_modifier_type(struct connection *pc);
+int send_packet_ruleset_modifier(struct connection *pc,
+                const struct packet_ruleset_modifier *packet);
+struct packet_ruleset_modifier *
+receive_packet_ruleset_modifier(struct connection *pc);
+int send_packet_request_compound(struct connection *pc,
+    				 struct packet_request_compound *req);
+struct packet_request_compound *
+receive_packet_request_compound(struct connection *pc);
+
 int send_packet_ruleset_tech(struct connection *pc,
 			     const struct packet_ruleset_tech *packet);
 struct packet_ruleset_tech *
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets_lsend.c freeciv-patched/common/packets_lsend.c
--- freeciv-cvs/common/packets_lsend.c	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/packets_lsend.c	2003-07-07 18:21:49.000000000 +0100
@@ -239,6 +239,30 @@
   conn_list_iterate_end;
 }
 
+void lsend_packet_ruleset_modifier_type(struct conn_list *dest,
+                const struct packet_ruleset_modifier_type *packet)
+{
+  conn_list_iterate(*dest, pconn)
+    send_packet_ruleset_modifier_type(pconn, packet);
+  conn_list_iterate_end;
+}
+
+void lsend_packet_ruleset_modifier(struct conn_list *dest,
+                const struct packet_ruleset_modifier *packet)
+{
+  conn_list_iterate(*dest, pconn)
+    send_packet_ruleset_modifier(pconn, packet);
+  conn_list_iterate_end;
+}
+
+void lsend_packet_request_compound(struct conn_list *dest,
+    				 struct packet_request_compound *req)
+{
+  conn_list_iterate(*dest, pconn)
+    send_packet_request_compound(pconn, req);
+  conn_list_iterate_end;
+}
+
 void lsend_packet_ruleset_tech(struct conn_list *dest,
 			     const struct packet_ruleset_tech *packet)
 {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets_lsend.h freeciv-patched/common/packets_lsend.h
--- freeciv-cvs/common/packets_lsend.h	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/packets_lsend.h	2003-07-07 18:21:49.000000000 +0100
@@ -72,6 +72,12 @@
 				const struct packet_ruleset_control *packet);
 void lsend_packet_ruleset_unit(struct conn_list *dest,
 			     const struct packet_ruleset_unit *packet);
+void lsend_packet_ruleset_modifier_type(struct conn_list *dest,
+                const struct packet_ruleset_modifier_type *packet);
+void lsend_packet_ruleset_modifier(struct conn_list *dest,
+                const struct packet_ruleset_modifier *packet);
+void lsend_packet_request_compound(struct conn_list *dest,
+    				 struct packet_request_compound *req);
 void lsend_packet_ruleset_tech(struct conn_list *dest,
 			     const struct packet_ruleset_tech *packet);
 void lsend_packet_ruleset_building(struct conn_list *dest,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/script.c freeciv-patched/common/script.c
--- freeciv-cvs/common/script.c	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/script.c	2003-07-07 18:21:49.000000000 +0100
@@ -0,0 +1,346 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <assert.h>
+#include <string.h>
+#include <slang/slang.h>
+
+#include "fcintl.h"
+#include "game.h"
+#include "government.h"
+#include "log.h"
+#include "shared.h"
+#include "support.h"
+#include "unit.h"
+
+#include "script.h"
+
+static void ut_set_name(int *id, char *name)
+{
+  struct unit_type *ut = get_unit_type(*id);
+  sz_strlcpy(ut->name_orig, name);
+  sz_strlcpy(ut->name, _(name));
+}
+
+static void ut_set_graphic(int *id, char *name, char *name_alt)
+{
+  struct unit_type *ut = get_unit_type(*id);
+  sz_strlcpy(ut->graphic_str, name);
+  sz_strlcpy(ut->graphic_alt, name_alt);
+}
+
+static void ut_set_move_rate(int *id, int *move_rate)
+{
+  struct unit_type *ut = get_unit_type(*id);
+  ut->move_rate = *move_rate * SINGLE_MOVE;
+}
+
+struct members {
+  char *name;
+  unsigned long offset;
+};
+
+#define FC_UT_MEMBER(member, name) \
+  {#name, ((unsigned long) ((char *) &((struct unit_type *)0)->member))}
+
+#define FC_MEMBER_P(struct_p, offset) \
+  ((int *) ((char *)(struct_p) + offset))
+
+static struct members ut_members[] =
+{
+  FC_UT_MEMBER(move_type, move_type),
+  FC_UT_MEMBER(build_cost, build_cost),
+  FC_UT_MEMBER(pop_cost, pop_cost),
+  FC_UT_MEMBER(attack_strength, attack),
+  FC_UT_MEMBER(defense_strength, defense),
+  FC_UT_MEMBER(vision_range, vision_range),
+  FC_UT_MEMBER(transport_capacity, transport_cap),
+  FC_UT_MEMBER(hp, hitpoints),
+  FC_UT_MEMBER(firepower, firepower),
+  FC_UT_MEMBER(fuel, fuel),
+  FC_UT_MEMBER(happy_cost, uk_happy),
+  FC_UT_MEMBER(shield_cost, uk_shield),
+  FC_UT_MEMBER(food_cost, uk_food),
+  FC_UT_MEMBER(gold_cost, uk_gold)
+};
+#define num_ut_members (sizeof(ut_members) / sizeof(ut_members[0]))
+
+static void ut_get(int *id)
+{
+  char *field_names[num_ut_members + 6];
+  unsigned char field_types[num_ut_members + 6];
+  VOID_STAR field_values[num_ut_members + 6];
+  struct unit_type *ut = get_unit_type(*id);
+  int move_rate = ut->move_rate / SINGLE_MOVE;
+  char *name = ut->name_orig;
+  char *graphic = ut->graphic_str, *graphic_alt = ut->graphic_alt;
+  int i;
+
+  for (i = 0; i < num_ut_members; i++) {
+    field_names[i] = ut_members[i].name;
+    field_types[i] = SLANG_INT_TYPE;
+    field_values[i] = FC_MEMBER_P(ut, ut_members[i].offset);
+  }
+
+  field_names[i] = "name";
+  field_types[i] = SLANG_STRING_TYPE;
+  field_values[i++] = &name;
+
+  field_names[i] = "graphic";
+  field_types[i] = SLANG_STRING_TYPE;
+  field_values[i++] = &graphic;
+
+  field_names[i] = "graphic_alt";
+  field_types[i] = SLANG_STRING_TYPE;
+  field_values[i++] = &graphic_alt;
+
+  field_names[i] = "move_rate";
+  field_types[i] = SLANG_INT_TYPE;
+  field_values[i++] = &move_rate;
+
+  field_names[i] = "flags";
+  field_types[i] = SLANG_NULL_TYPE;
+  field_values[i++] = NULL;
+
+  field_names[i] = "roles";
+  field_types[i] = SLANG_NULL_TYPE;
+  field_values[i++] = NULL;
+
+  SLstruct_create_struct(i, field_names, field_types, field_values);
+}
+
+static void ut_set_ints(void)
+{
+  int i, id;
+  unsigned int num = SLang_Num_Function_Args;
+  struct unit_type *ut;
+
+  assert(num == num_ut_members + 1);
+
+  SLang_pop_integer(&id);
+  ut = get_unit_type(id);
+
+  for (i = num_ut_members - 1; i >= 0; i--) {
+    int val, *pt;
+    SLang_pop_integer(&val);
+    pt = FC_MEMBER_P(ut, ut_members[i].offset);
+    *pt = val;
+  }
+}
+
+static void gt_set_name(int *id, char *name)
+{
+  struct government *gov = get_government(*id);
+  sz_strlcpy(gov->name_orig, name);
+  sz_strlcpy(gov->name, _(name));
+}
+
+#define FC_GT_MEMBER(member, name) \
+  {#name, ((unsigned long) ((char *) &((struct government *)0)->member))}
+
+static struct members gt_members[] =
+{
+  FC_GT_MEMBER(max_rate, max_single_rate),
+  FC_GT_MEMBER(civil_war, civil_war_chance),
+  FC_GT_MEMBER(free_happy, unit_free_unhappy),
+  FC_GT_MEMBER(free_shield, unit_free_shield),
+  FC_GT_MEMBER(free_food, unit_free_food),
+  FC_GT_MEMBER(free_gold, unit_free_gold)
+};
+#define num_gt_members (sizeof(gt_members) / sizeof(gt_members[0]))
+
+static void gt_get(int *id)
+{
+  char *field_names[num_gt_members + 3];
+  unsigned char field_types[num_gt_members + 3];
+  VOID_STAR field_values[num_gt_members + 3];
+  struct government *gov = get_government(*id);
+  char *name = gov->name_orig;
+  char *graphic = gov->graphic_str, *graphic_alt = gov->graphic_alt;
+  int i;
+
+  for (i = 0; i < num_gt_members; i++) {
+    field_names[i] = gt_members[i].name;
+    field_types[i] = SLANG_INT_TYPE;
+    field_values[i] = FC_MEMBER_P(gov, gt_members[i].offset);
+  }
+
+  field_names[i] = "name";
+  field_types[i] = SLANG_STRING_TYPE;
+  field_values[i++] = &name;
+
+  field_names[i] = "graphic";
+  field_types[i] = SLANG_STRING_TYPE;
+  field_values[i++] = &graphic;
+
+  field_names[i] = "graphic_alt";
+  field_types[i] = SLANG_STRING_TYPE;
+  field_values[i++] = &graphic_alt;
+
+  SLstruct_create_struct(i, field_names, field_types, field_values);
+}
+
+static void sl_freelog(char *str)
+{
+  freelog(LOG_NORMAL, "%s", str);
+}
+
+static void ut_get_flags(int *id)
+{
+  int i, dims[1] = {F_LAST};
+  SLang_Array_Type *arr;
+
+  arr = SLang_create_array(SLANG_INT_TYPE, 0, NULL, dims, 1);
+
+  for (i = 0; i < F_LAST; i++) {
+    int val = unit_type_flag(*id, i) ? 1 : 0;
+    dims[0] = i;
+    SLang_set_array_element(arr, dims, &val);
+  }
+
+  SLang_push_array(arr, 1);
+}
+
+static void ut_set_flags(void)
+{
+  SLang_Array_Type *arr;
+  int id, i;
+  struct unit_type *ut;
+
+  SLang_pop_array_of_type(&arr, SLANG_INT_TYPE);
+  assert(arr->num_dims == 1 && arr->dims[0] == F_LAST);
+
+  SLang_pop_integer(&id);
+  ut = get_unit_type(id);
+  BV_CLR_ALL(ut->flags);
+  for (i = 0; i < F_LAST; i++) {
+    int val;
+    SLang_get_array_element(arr, &i, &val);
+    if (val) {
+      BV_SET(ut->flags, i);
+    }
+  }
+  SLang_free_array(arr);
+}
+
+static void ut_get_roles(int *id)
+{
+  int i, dims[1] = {L_LAST - L_FIRST};
+  SLang_Array_Type *arr;
+
+  arr = SLang_create_array(SLANG_INT_TYPE, 0, NULL, dims, 1);
+
+  for (i = L_FIRST; i < L_LAST; i++) {
+    int val = unit_has_role(*id, i) ? 1 : 0;
+    dims[0] = i - L_FIRST;
+    SLang_set_array_element(arr, dims, &val);
+  }
+
+  SLang_push_array(arr, 1);
+}
+
+static void ut_set_roles(void)
+{
+  SLang_Array_Type *arr;
+  int id, i;
+  struct unit_type *ut;
+
+  SLang_pop_array_of_type(&arr, SLANG_INT_TYPE);
+  assert(arr->num_dims == 1 && arr->dims[0] == L_LAST - L_FIRST);
+
+  SLang_pop_integer(&id);
+  ut = get_unit_type(id);
+  BV_CLR_ALL(ut->roles);
+  for (i = 0; i < L_LAST - L_FIRST; i++) {
+    int val;
+    SLang_get_array_element(arr, &i, &val);
+    if (val) {
+      BV_SET(ut->roles, i);
+    }
+  }
+  SLang_free_array(arr);
+}
+
+static void register_intrinsics(void)
+{
+  char buffer[1024];
+  static SLang_Intrin_Fun_Type intrins[] =
+  {
+    MAKE_INTRINSIC_I("ut_get", ut_get, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_IS("ut_set_name", ut_set_name, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_ISS("ut_set_graphic", ut_set_graphic, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_II("ut_set_move_rate", ut_set_move_rate, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_0("ut_set_flags", ut_set_flags, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_I("ut_get_flags", ut_get_flags, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_0("ut_set_roles", ut_set_roles, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_I("ut_get_roles", ut_get_roles, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_0("ut_set_ints", ut_set_ints, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_S("unit_flag_from_str", unit_flag_from_str, SLANG_INT_TYPE),
+    MAKE_INTRINSIC_S("unit_role_from_str", unit_role_from_str, SLANG_INT_TYPE),
+    MAKE_INTRINSIC_I("gt_get", gt_get, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_IS("gt_set_name", gt_set_name, SLANG_VOID_TYPE),
+    MAKE_INTRINSIC_S("freelog", sl_freelog, SLANG_VOID_TYPE),
+    SLANG_END_INTRIN_FUN_TABLE
+  };
+  SLadd_intrin_fun_table(intrins, NULL);
+  my_snprintf(buffer, sizeof(buffer),
+              "variable Land = %d, Sea = %d, Heli = %d, Air = %d;",
+	      LAND_MOVING, SEA_MOVING, HELI_MOVING, AIR_MOVING);
+  SLang_load_string(buffer);
+  my_snprintf(buffer, sizeof(buffer),
+              "variable F_LAST = %d, L_LAST = %d, L_FIRST = %d;",
+	      F_LAST, L_LAST, L_FIRST);
+  SLang_load_string(buffer);
+}
+
+void script_test(void)
+{
+  SLang_load_file("test.sl");
+}
+
+void script_execute(char *cmds)
+{
+  if (cmds) {
+    if (SLang_load_string(cmds) == -1) {
+      SLang_restart(1);
+      SLang_Error = 0;
+    }
+  }
+}
+
+void script_load_library(void)
+{
+  char filename[512], *dfilename;
+
+  my_snprintf(filename, sizeof(filename), "%s/library.sl", game.rulesetdir);
+  dfilename = datafilename(filename);
+  if (dfilename) {
+    if (SLang_load_file(dfilename) == -1) {
+      SLang_restart(1);
+      SLang_Error = 0;
+    }
+  }
+}
+
+void script_init(void)
+{
+  if (SLang_init_slang() == -1) {
+    freelog(LOG_ERROR, "SLang init error");
+  } else {
+    register_intrinsics();
+  }
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/script.h freeciv-patched/common/script.h
--- freeciv-cvs/common/script.h	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/script.h	2003-07-07 18:21:49.000000000 +0100
@@ -0,0 +1,21 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+#ifndef FC__SCRIPT_H
+#define FC__SCRIPT_H
+
+void script_init(void);
+void script_load_library(void);
+void script_test(void);
+void script_execute(char *cmds);
+
+#endif /* FC__SCRIPT_H */
